/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2011 - 2012 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * http://glassfish.java.net/public/CDDL+GPL_1_1.html
 * or packager/legal/LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at packager/legal/LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */
package org.glassfish.websocket.sample.auction;

import org.glassfish.websocket.sample.auction.message.ResultMessage;
import org.glassfish.websocket.sample.auction.message.AuctionClosedResponseMessage;
import org.glassfish.websocket.sample.auction.message.AuctionTimeBroadcastMessage;
import org.glassfish.websocket.sample.auction.message.PreAuctionTimeBroadcastMessage;
import org.glassfish.websocket.sample.auction.message.AuctionListResponseMessage;
import org.glassfish.websocket.sample.auction.message.PriceUpdateResponseMessage;
import org.glassfish.websocket.sample.auction.message.LoginResponseMessage;
import java.io.IOException;
import org.glassfish.websocket.api.ConversionException;
import org.glassfish.websocket.api.Peer;
import org.glassfish.websocket.api.annotations.WebSocketRemote;

/**
 *
 * @author Stepan Kopriva (stepan.kopriva at oracle.com)
 */
@WebSocketRemote(encoders = {org.glassfish.websocket.sample.auction.encoders.LoginResponseEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.PriceUpdateResponseEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.AuctionClosedResponseEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.PreAuctionTimeBroadcastEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.AuctionTimeBroadcastEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.ResultEncoder.class,
    org.glassfish.websocket.sample.auction.encoders.AuctionListResponseEncoder.class})
public interface AuctionRemoteClient extends Peer {

    public void sendLoginResponse(LoginResponseMessage lrm) throws IOException, ConversionException;

    public void sendPriceUpdate(PriceUpdateResponseMessage purm) throws IOException, ConversionException;

    public void auctionClosed(AuctionClosedResponseMessage acrm) throws IOException, ConversionException;

    public void sendPreAuctionTimeBroadcast(PreAuctionTimeBroadcastMessage patbm) throws IOException, ConversionException;

    public void sendAuctionTimeBroadcast(AuctionTimeBroadcastMessage atbm) throws IOException, ConversionException;

    public void sendResultMessage(ResultMessage rm) throws IOException, ConversionException;

    public void sendAuctionListMessage(AuctionListResponseMessage alrm) throws IOException, ConversionException;
}
